org.apache.lucene.search.spans

## Class NearSpansOrdered

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.search.spans.Spans
    - - org.apache.lucene.search.spans.NearSpansOrdered

-     public class NearSpansOrdered
      extends Spans

  A Spans that is formed from the ordered subspans of a SpanNearQuery where the subspans do not overlap and have a maximum slop between them.

  The formed spans only contains minimum slop matches.
  The matching slop is computed from the distance(s) between the non overlapping matching Spans.
  Successive matches are always formed from the successive Spans of the SpanNearQuery.

  The formed spans may contain overlaps when the slop is at least 1. For example, when querying using

      t1 t2 t3

  with slop at least 1, the fragment:

      t1 t2 t1 t3 t2 t3

  matches twice:

      t1 t2 .. t3

            t1 .. t2 t3

  Expert: Only public for subclassing. Most implementations should not need this class

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `matchEnd`
    `protected int` | `matchStart`
    `protected int` | `matchWidth`

    - ### Fields inherited from class org.apache.lucene.search.spans.Spans

      `NO_MORE_POSITIONS`

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `NearSpansOrdered(int allowedSlop, List<Spans> subSpans)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int target)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `TwoPhaseIterator` | `asTwoPhaseIterator()` Return a `TwoPhaseIterator` view of this ConjunctionSpans.
    `void` | `collect(SpanCollector collector)` Collect postings data from the leaves of the current Spans.
    `long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
    `int` | `docID()` Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `int` | `endPosition()` Returns the end position for the current start position, or -1 when `Spans.nextStartPosition()` was not yet called on the current doc.
    `Spans[]` | `getSubSpans()`
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `int` | `nextStartPosition()` Returns the next start position for the current doc.
    `float` | `positionsCost()` Return an estimation of the cost of using the positions of this `Spans` for any single document, but only after `Spans.asTwoPhaseIterator()` returned `null`.
    `int` | `startPosition()` Returns the start position in the current doc, or -1 when `Spans.nextStartPosition()` was not yet called on the current doc.
    `int` | `width()` Return the width of the match, which is typically used to sloppy freq.

    - ### Methods inherited from class org.apache.lucene.search.spans.Spans

      `doCurrentSpans, doStartCurrentDoc, toString`

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `all, empty, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### matchStart

          protected int matchStart

    - #### matchEnd

          protected int matchEnd

    - #### matchWidth

          protected int matchWidth

  - ### Constructor Detail

    - #### NearSpansOrdered

          public NearSpansOrdered(int allowedSlop,
                                  List<Spans> subSpans)
                           throws IOException

      Throws:
        `IOException`

  - ### Method Detail

    - #### nextStartPosition

          public int nextStartPosition()
                                throws IOException

      Description copied from class: `Spans`
      Returns the next start position for the current doc. There is always at least one start/end position per doc. After the last start/end position at the current doc this returns `Spans.NO_MORE_POSITIONS`.
      Specified by:
        `nextStartPosition` in class `Spans`
      Throws:
        `IOException`

    - #### startPosition

          public int startPosition()

      Description copied from class: `Spans`
      Returns the start position in the current doc, or -1 when `Spans.nextStartPosition()` was not yet called on the current doc. After the last start/end position at the current doc this returns `Spans.NO_MORE_POSITIONS`.
      Specified by:
        `startPosition` in class `Spans`

    - #### endPosition

          public int endPosition()

      Description copied from class: `Spans`
      Returns the end position for the current start position, or -1 when `Spans.nextStartPosition()` was not yet called on the current doc. After the last start/end position at the current doc this returns `Spans.NO_MORE_POSITIONS`.
      Specified by:
        `endPosition` in class `Spans`

    - #### width

          public int width()

      Description copied from class: `Spans`
      Return the width of the match, which is typically used to sloppy freq. It is only legal to call this method when the iterator is on a valid doc ID and positioned. The return value must be positive, and lower values means that the match is better.
      Specified by:
        `width` in class `Spans`

    - #### collect

          public void collect(SpanCollector collector)
                       throws IOException

      Description copied from class: `Spans`
      Collect postings data from the leaves of the current Spans. This method should only be called after `Spans.nextStartPosition()`, and before `Spans.NO_MORE_POSITIONS` has been reached.
      Specified by:
        `collect` in class `Spans`
      Parameters:
        `collector` - a SpanCollector
      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### cost

          public long cost()

      Description copied from class: `DocIdSetIterator`
      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

      Specified by:
        `cost` in class `DocIdSetIterator`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### advance

          public int advance(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### asTwoPhaseIterator

          public TwoPhaseIterator asTwoPhaseIterator()

      Return a `TwoPhaseIterator` view of this ConjunctionSpans.
      Overrides:
        `asTwoPhaseIterator` in class `Spans`
      See Also:
        `Scorer.twoPhaseIterator()`

    - #### positionsCost

          public float positionsCost()

      Description copied from class: `Spans`
      Return an estimation of the cost of using the positions of this `Spans` for any single document, but only after `Spans.asTwoPhaseIterator()` returned `null`. Otherwise this method should not be called. The returned value is independent of the current document.
      Specified by:
        `positionsCost` in class `Spans`

    - #### getSubSpans

          public Spans[] getSubSpans()

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.